<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.6"/>
<title>TIML: appCNNInteropCaffe.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIML
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.6 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_4f218e5c1c68a8760266841df915118e.html">src</a></li><li class="navelem"><a class="el" href="dir_230ff266809b6c822309e6868f081b10.html">app</a></li><li class="navelem"><a class="el" href="dir_e5b67a8a4144e6ae177326db1accf5e2.html">cnn</a></li><li class="navelem"><a class="el" href="dir_9f7102c8977c4304c9632e12c71e1972.html">interop</a></li><li class="navelem"><a class="el" href="dir_ce1800c9a1795cf1469eaaa9bf86db13.html">caffe</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">appCNNInteropCaffe.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="appCNNInteropCaffe_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef APPCNNINTEROPCAFFE_HPP_</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#define APPCNNINTEROPCAFFE_HPP_</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="comment"> *  INCLUDES</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="preprocessor">#include &lt;google/protobuf/io/coded_stream.h&gt;</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="preprocessor">#include &lt;google/protobuf/io/zero_copy_stream_impl.h&gt;</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="preprocessor">#include &lt;google/protobuf/message.h&gt;</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="preprocessor">#include &lt;google/protobuf/text_format.h&gt;</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="preprocessor">#include &lt;fcntl.h&gt;</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="preprocessor">#include &quot;appCNNInteropCaffeProtobuf.hpp&quot;</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="timl_8h.html">timl.h</a>&quot;</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;}</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="keyword">using namespace </span>caffe;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;using ::google::protobuf::Message;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;using ::google::protobuf::io::FileInputStream;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;using ::google::protobuf::io::FileOutputStream;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;using ::google::protobuf::io::ZeroCopyInputStream;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;using ::google::protobuf::io::CodedInputStream;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;using ::google::protobuf::io::ZeroCopyOutputStream;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;using ::google::protobuf::io::CodedOutputStream;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="comment"> * DEFINES</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="keyword">typedef</span> <span class="keyword">enum</span> {</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;   ERROR_APP_CNN_INTEROP_ARG,</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;   ERROR_APP_CNN_INTEROP_READ_FIEL</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;} appCNNInteropError;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="comment"> * FUNCTION PROTOTYPES</span></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="group__appCNNInteropCaffe.html#ga7052f4eb157d65957ad3fd2332438522">appCNNInteropCaffeReadProtoFromTextFile</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* filename, Message* proto);</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="comment">//void appCNNInteropCaffeWriteProtoToTextFile(const Message&amp; proto, const char* filename);</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="group__appCNNInteropCaffe.html#ga622145415a86ef826c3e8017fb478db6">appCNNInteropCaffeReadProtoFromBinaryFile</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* filename, Message* proto);</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="comment">//void appCNNInteropCaffeWriteProtoToBinaryFile(const Message&amp; proto, const char* filename);</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__appCNNInteropCaffe.html#ga335d05efc7a9d315db56be13fc0af111">appCNNInteropCaffeFlipMatrixFloat</a>(<span class="keywordtype">float</span> *a, <span class="keywordtype">int</span> m, <span class="keywordtype">int</span> n);</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__appCNNInteropCaffe.html#ga4d2f15bd3e322f77cbc47edf00f9ef36">appCNNInteropCaffeFlipKernelMatrix</a>(<span class="keywordtype">float</span> *kernel, <span class="keywordtype">int</span> kernelRow, <span class="keywordtype">int</span> kernelCol, <span class="keywordtype">int</span> inputChannel, <span class="keywordtype">int</span> outputChannel);</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__appCNNInteropCaffe.html#ga9a4b55d7ec059ee00c3c6b6d5743f9f7">appCNNInteropCaffeFillBlockDiagonalMatrix</a>(<span class="keywordtype">float</span> *a, <span class="keywordtype">int</span> M, <span class="keywordtype">int</span> N, <span class="keywordtype">int</span> group, <span class="keywordtype">float</span> *b);</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;timlUtilActivationType <a class="code" href="group__appCNNInteropCaffe.html#ga630a9d1314c2151e7193de73a714b789">appCNNInteropCaffeNonlinearTypeConvert</a>(LayerParameter_LayerType type);</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;timlCNNLayerType <a class="code" href="group__appCNNInteropCaffe.html#ga3752b452e61029bc03d4f10b95d0a861">appCNNInteropCaffeLayerTypeConvert</a>(LayerParameter_LayerType type);</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;timlCNNPoolingType <a class="code" href="group__appCNNInteropCaffe.html#ga3106ebef164cd39f0bc864c59c2c0a45">appCNNInteropCaffePoolingTypeConvert</a>(PoolingParameter_PoolMethod method);</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a>* <a class="code" href="group__appCNNInteropCaffe.html#ga2ce06f0ef11d677b3087a59857797335">appCNNInteropCaffeConvert</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *netStructurePrototxtFileName, <span class="keyword">const</span> <span class="keywordtype">char</span> *netParamPrototxtFileName);</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__appCNNInteropCaffe.html#ga17ffed596b6ee6d57574915f1eaaaf23">appCNNInteropCaffeConvLayerConvert</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam);</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__appCNNInteropCaffe.html#ga9dfa0736763aefc3d820ca27e7a19882">appCNNInteropCaffeConvLayerPermuteKernel</a>(<a class="code" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer);</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__appCNNInteropCaffe.html#gae61e927bb0b0fd6cca3dd1a45f8a1e62">appCNNInteropCaffePoolingLayerConvert</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam);</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__appCNNInteropCaffe.html#ga7ac38ac27f861867ee84e038428d2139">appCNNInteropCaffeNormLayerConvert</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam);</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__appCNNInteropCaffe.html#ga53805074229f6d101a0b3c91dce8216b">appCNNInteropCaffeLinearLayerConvert</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam);</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__appCNNInteropCaffe.html#gab913f62c0b33ce7bc646d2877e9fb748">appCNNInteropCaffeNonlinearLayerConvert</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam);</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__appCNNInteropCaffe.html#gaf982a0ff86bbbfffaa342f80b3f46cb5">appCNNInteropCaffeDropoutLayerConvert</a>(<a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam);</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__appCNNInteropCaffe.html#gab530bd6ef77e6850fb50355ce85f8ff8">appCNNInteropCaffeReadMean</a>(<a class="code" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer, <span class="keyword">const</span> <span class="keywordtype">char</span> *fileName);</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="keywordtype">int</span> <a class="code" href="group__appCNNInteropCaffe.html#gaa86fc855715a800c4e27a31159c39207">appCNNInteropCaffePermuteMean</a>(<span class="keywordtype">float</span> *mean, <span class="keywordtype">int</span> row, <span class="keywordtype">int</span> col, <span class="keywordtype">int</span> channel);</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* APPCNNINTEROPCAFFE_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_ga9dfa0736763aefc3d820ca27e7a19882"><div class="ttname"><a href="group__appCNNInteropCaffe.html#ga9dfa0736763aefc3d820ca27e7a19882">appCNNInteropCaffeConvLayerPermuteKernel</a></div><div class="ttdeci">int appCNNInteropCaffeConvLayerPermuteKernel(timlCNNLayer *layer)</div><div class="ttdoc">Change the kernel from BGR squence to RGB. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffeConvLayerPermuteKernel.cpp:56</div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_gaa86fc855715a800c4e27a31159c39207"><div class="ttname"><a href="group__appCNNInteropCaffe.html#gaa86fc855715a800c4e27a31159c39207">appCNNInteropCaffePermuteMean</a></div><div class="ttdeci">int appCNNInteropCaffePermuteMean(float *mean, int row, int col, int channel)</div><div class="ttdoc">Permute the mean in the input layer from BGR sequence to RGB. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffePermuteMean.cpp:60</div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_ga3752b452e61029bc03d4f10b95d0a861"><div class="ttname"><a href="group__appCNNInteropCaffe.html#ga3752b452e61029bc03d4f10b95d0a861">appCNNInteropCaffeLayerTypeConvert</a></div><div class="ttdeci">timlCNNLayerType appCNNInteropCaffeLayerTypeConvert(LayerParameter_LayerType type)</div><div class="ttdoc">Caffe to TIML CNN layer type conversion. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffeLayerTypeConvert.cpp:57</div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_gab530bd6ef77e6850fb50355ce85f8ff8"><div class="ttname"><a href="group__appCNNInteropCaffe.html#gab530bd6ef77e6850fb50355ce85f8ff8">appCNNInteropCaffeReadMean</a></div><div class="ttdeci">int appCNNInteropCaffeReadMean(timlCNNLayer *layer, const char *fileName)</div><div class="ttdoc">Read Caffe mean binary file. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffeReadMean.cpp:58</div></div>
<div class="ttc" id="struct__timlConvNeuralNetwork___html"><div class="ttname"><a href="struct__timlConvNeuralNetwork__.html">_timlConvNeuralNetwork_</a></div><div class="ttdef"><b>Definition:</b> timlCNN.h:257</div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_ga53805074229f6d101a0b3c91dce8216b"><div class="ttname"><a href="group__appCNNInteropCaffe.html#ga53805074229f6d101a0b3c91dce8216b">appCNNInteropCaffeLinearLayerConvert</a></div><div class="ttdeci">int appCNNInteropCaffeLinearLayerConvert(timlConvNeuralNetwork *cnn, LayerParameter layerStructure, LayerParameter layerParam)</div><div class="ttdoc">Caffe linear layer conversion. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffeLinearLayerConvert.cpp:59</div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_ga2ce06f0ef11d677b3087a59857797335"><div class="ttname"><a href="group__appCNNInteropCaffe.html#ga2ce06f0ef11d677b3087a59857797335">appCNNInteropCaffeConvert</a></div><div class="ttdeci">timlConvNeuralNetwork * appCNNInteropCaffeConvert(const char *netStructurePrototxtFileName, const char *netParamPrototxtFileName)</div><div class="ttdoc">Convert Caffe to TIML CNN. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffeConvert.cpp:57</div></div>
<div class="ttc" id="struct__timlCNNLayer___html"><div class="ttname"><a href="struct__timlCNNLayer__.html">_timlCNNLayer_</a></div><div class="ttdef"><b>Definition:</b> timlCNN.h:222</div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_ga7ac38ac27f861867ee84e038428d2139"><div class="ttname"><a href="group__appCNNInteropCaffe.html#ga7ac38ac27f861867ee84e038428d2139">appCNNInteropCaffeNormLayerConvert</a></div><div class="ttdeci">int appCNNInteropCaffeNormLayerConvert(timlConvNeuralNetwork *cnn, LayerParameter layerStructure, LayerParameter layerParam)</div><div class="ttdoc">Caffe norm layer conversion. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffeNormLayerConvert.cpp:61</div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_ga630a9d1314c2151e7193de73a714b789"><div class="ttname"><a href="group__appCNNInteropCaffe.html#ga630a9d1314c2151e7193de73a714b789">appCNNInteropCaffeNonlinearTypeConvert</a></div><div class="ttdeci">timlUtilActivationType appCNNInteropCaffeNonlinearTypeConvert(LayerParameter_LayerType type)</div><div class="ttdoc">Caffe nonlinear layer type conversion. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffeNonlinearTypeConvert.cpp:58</div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_gaf982a0ff86bbbfffaa342f80b3f46cb5"><div class="ttname"><a href="group__appCNNInteropCaffe.html#gaf982a0ff86bbbfffaa342f80b3f46cb5">appCNNInteropCaffeDropoutLayerConvert</a></div><div class="ttdeci">int appCNNInteropCaffeDropoutLayerConvert(timlConvNeuralNetwork *cnn, LayerParameter layerStructure, LayerParameter layerParam)</div><div class="ttdoc">Caffe dropout layer conversion. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffeDropoutLayerConvert.cpp:58</div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_ga3106ebef164cd39f0bc864c59c2c0a45"><div class="ttname"><a href="group__appCNNInteropCaffe.html#ga3106ebef164cd39f0bc864c59c2c0a45">appCNNInteropCaffePoolingTypeConvert</a></div><div class="ttdeci">timlCNNPoolingType appCNNInteropCaffePoolingTypeConvert(PoolingParameter_PoolMethod method)</div><div class="ttdoc">Caffe pooling type conversion. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffePoolingTypeConvert.cpp:57</div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_ga9a4b55d7ec059ee00c3c6b6d5743f9f7"><div class="ttname"><a href="group__appCNNInteropCaffe.html#ga9a4b55d7ec059ee00c3c6b6d5743f9f7">appCNNInteropCaffeFillBlockDiagonalMatrix</a></div><div class="ttdeci">int appCNNInteropCaffeFillBlockDiagonalMatrix(float *a, int M, int N, int group, float *b)</div><div class="ttdoc">Fill a block diagonal matrix. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffeFillBlockDiagonalMatrix.cpp:60</div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_ga4d2f15bd3e322f77cbc47edf00f9ef36"><div class="ttname"><a href="group__appCNNInteropCaffe.html#ga4d2f15bd3e322f77cbc47edf00f9ef36">appCNNInteropCaffeFlipKernelMatrix</a></div><div class="ttdeci">int appCNNInteropCaffeFlipKernelMatrix(float *kernel, int kernelRow, int kernelCol, int inputChannel, int outputChannel)</div><div class="ttdoc">Flip the kernels. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffeFlipKernelMatrix.cpp:60</div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_ga7052f4eb157d65957ad3fd2332438522"><div class="ttname"><a href="group__appCNNInteropCaffe.html#ga7052f4eb157d65957ad3fd2332438522">appCNNInteropCaffeReadProtoFromTextFile</a></div><div class="ttdeci">bool appCNNInteropCaffeReadProtoFromTextFile(const char *filename, Message *proto)</div><div class="ttdoc">Caffe read proto from text file. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffeReadProtoFromTextFile.cpp:58</div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_ga17ffed596b6ee6d57574915f1eaaaf23"><div class="ttname"><a href="group__appCNNInteropCaffe.html#ga17ffed596b6ee6d57574915f1eaaaf23">appCNNInteropCaffeConvLayerConvert</a></div><div class="ttdeci">int appCNNInteropCaffeConvLayerConvert(timlConvNeuralNetwork *cnn, LayerParameter layerStructure, LayerParameter layerParam)</div><div class="ttdoc">Convert Caffe conv layer. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffeConvLayerConvert.cpp:58</div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_ga622145415a86ef826c3e8017fb478db6"><div class="ttname"><a href="group__appCNNInteropCaffe.html#ga622145415a86ef826c3e8017fb478db6">appCNNInteropCaffeReadProtoFromBinaryFile</a></div><div class="ttdeci">bool appCNNInteropCaffeReadProtoFromBinaryFile(const char *filename, Message *proto)</div><div class="ttdoc">Caffe read proto from binary file. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffeReadProtoFromBinaryFile.cpp:68</div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_ga335d05efc7a9d315db56be13fc0af111"><div class="ttname"><a href="group__appCNNInteropCaffe.html#ga335d05efc7a9d315db56be13fc0af111">appCNNInteropCaffeFlipMatrixFloat</a></div><div class="ttdeci">int appCNNInteropCaffeFlipMatrixFloat(float *a, int m, int n)</div><div class="ttdoc">Flip a matrix. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffeFlipMatrixFloat.cpp:58</div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_gab913f62c0b33ce7bc646d2877e9fb748"><div class="ttname"><a href="group__appCNNInteropCaffe.html#gab913f62c0b33ce7bc646d2877e9fb748">appCNNInteropCaffeNonlinearLayerConvert</a></div><div class="ttdeci">int appCNNInteropCaffeNonlinearLayerConvert(timlConvNeuralNetwork *cnn, LayerParameter layerStructure, LayerParameter layerParam)</div><div class="ttdoc">Caffe nonlinear layer conversion. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffeNonlinearLayerConvert.cpp:59</div></div>
<div class="ttc" id="timl_8h_html"><div class="ttname"><a href="timl_8h.html">timl.h</a></div><div class="ttdoc">timl public APIs </div></div>
<div class="ttc" id="group__appCNNInteropCaffe_html_gae61e927bb0b0fd6cca3dd1a45f8a1e62"><div class="ttname"><a href="group__appCNNInteropCaffe.html#gae61e927bb0b0fd6cca3dd1a45f8a1e62">appCNNInteropCaffePoolingLayerConvert</a></div><div class="ttdeci">int appCNNInteropCaffePoolingLayerConvert(timlConvNeuralNetwork *cnn, LayerParameter layerStructure, LayerParameter layerParam)</div><div class="ttdoc">Caffe pooling layer conversion. </div><div class="ttdef"><b>Definition:</b> appCNNInteropCaffePoolingLayerConvert.cpp:59</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Mar 20 2015 11:26:08 for TIML by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.6
</small></address>
</body>
</html>
